# Interface CreatableModule<T>

#### Type Parameters

- #### T extends Module = Module

#### Hierarchy

- CreatableModule

- Defined in modules/packages/module/packages/model/dist/types/CreatableModule.d.ts:3

#####
Index

### Constructors

constructor

### Properties

configSchema
defaultLogger?

### Methods

create
factory

## Constructors

### constructor

- new CreatableModule(params): T

- #### Parameters

  - ##### params: T["params"]

  #### Returns T

  - Defined in modules/packages/module/packages/model/dist/types/CreatableModule.d.ts:6

## Properties

### configSchema

configSchema: string

- Defined in modules/packages/module/packages/model/dist/types/CreatableModule.d.ts:4

### `Optional` defaultLogger

defaultLogger?: Logger

- Defined in modules/packages/module/packages/model/dist/types/CreatableModule.d.ts:5

## Methods

### create

- create<T>(this, params?): Promise<T>

- #### Type Parameters

  - #### T extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, T>

  #### Parameters

  - ##### this: CreatableModule<T>

  - ##### `Optional` params: T["params"]

  #### Returns Promise<T>

  - Defined in modules/packages/module/packages/model/dist/types/CreatableModule.d.ts:7

### factory

- factory<T>(this, params?): CreatableModuleFactory<T>

- #### Type Parameters

  - #### T extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, T>

  #### Parameters

  - ##### this: CreatableModule<T>

  - ##### `Optional` params: T["params"]

  #### Returns CreatableModuleFactory<T>

  - Defined in modules/packages/module/packages/model/dist/types/CreatableModule.d.ts:8

Generated using TypeDoc